import QtQuick 2.5
import QtQuick.Controls 1.4

ApplicationWindow {
    visible: true
    width: 640
    height: 480
    title: qsTr("QTBUG-58811")

    TabView{
        anchors.fill: parent
        id: tabviewRoot
        function processValuesChanged(){
            myContainer.bodyText = urlencodedBodyModel.generateUrlEncodedBody();
        }
        Tab {
            id: bodyText
            title: "Tab1"
            TextField{
                id: bodyEditorId
                text: myContainer.bodyText
            }

            onVisibleChanged: {
                if(!bodyText.visible){
                    urlencodedBodyModel.generateUrlEncodedBodyFromRaw(myContainer.bodyText);
                }
            }
        }
        Tab {
            title: "Tab2"
            id: urlEncodedBodyTab

            ComponentCrash{
                id: urlEncodedBodyEditor
                onValuesChanged: {
                    tabviewRoot.processValuesChanged()
                }
            }
            onVisibleChanged: {
                if(!urlEncodedBodyTab.visible){
                    tabviewRoot.processValuesChanged();
                }
            }
        }
    }
}
